VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4305
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   8745
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4305
   ScaleWidth      =   8745
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   3135
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   6495
      _ExtentX        =   11456
      _ExtentY        =   5530
      _Version        =   393216
      AllowUserResizing=   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long

Private Const ERROR_SUCCESS = 0&

Private Const HKEY_LOCAL_MACHINE = &H80000002

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const SYNCHRONIZE = &H100000
Private Const KEY_ALL_ACCESS = _
    ((STANDARD_RIGHTS_ALL Or _
    KEY_QUERY_VALUE Or _
    KEY_SET_VALUE Or _
    KEY_CREATE_SUB_KEY Or _
    KEY_ENUMERATE_SUB_KEYS Or _
    KEY_NOTIFY Or KEY_CREATE_LINK) And _
    (Not SYNCHRONIZE))

' Make the FlexGrid's columns big enough to hold all values.
Private Sub SizeColumns(ByVal flx As MSFlexGrid)
Dim max_wid As Single
Dim wid As Single
Dim max_row As Integer
Dim r As Integer
Dim c As Integer

    max_row = flx.Rows - 1
    For c = 0 To flx.Cols - 1
        max_wid = 0
        For r = 0 To max_row
            wid = TextWidth(flx.TextMatrix(r, c))
            If max_wid < wid Then max_wid = wid
        Next r
        flx.ColWidth(c) = max_wid + 240
    Next c
End Sub

' Return a subkey's value.
Private Function GetKeyValue(ByVal key_root As Long, ByVal key_name As String, ByVal subkey_name As String) As String
Dim hKey As Long
Dim value As String
Dim length As Long
Dim value_type As Long
Dim key_num As Long
Dim file_time As FILETIME

    ' Open the key.
    If RegOpenKeyEx(key_root, key_name, _
            0&, KEY_QUERY_VALUE, hKey) <> ERROR_SUCCESS _
        Then Exit Function

    ' Get the subkey's value.
    length = 256
    value = Space$(length)
    If RegQueryValueEx(hKey, subkey_name, _
        0&, value_type, ByVal value, length) _
            <> ERROR_SUCCESS _
        Then Exit Function

    ' Remove the trailing null character.
    GetKeyValue = Left$(value, length - 1)

    ' Close the key.
    RegCloseKey hKey
End Function

Private Sub Form_Load()
Dim hKey As Long
Dim value As String
Dim length As Long
Dim value_type As Long
Dim key_num As Long
Dim subkey_name As String
Dim subkey_length As Long
Dim file_time As FILETIME

    ' Open HKEY_LOCAL_MACHINE\Software\ODBC\ODBC.INI.
    If RegOpenKeyEx(HKEY_LOCAL_MACHINE, _
        "Software\ODBC\ODBC.INI", _
        0&, KEY_ALL_ACCESS, hKey) <> ERROR_SUCCESS _
    Then
        MsgBox "Error opening key."
        Exit Sub
    End If

    MSFlexGrid1.Rows = 1
    MSFlexGrid1.Cols = 3
    MSFlexGrid1.TextMatrix(0, 0) = "Name"
    MSFlexGrid1.TextMatrix(0, 1) = "Driver"
    MSFlexGrid1.TextMatrix(0, 2) = "Description"

    ' Enumerate the subkeys, skipping "ODBC Data Sources."
    key_num = 0
    Do
        ' Get the subkey's information.
        subkey_length = 256
        subkey_name = Space$(subkey_length)
        If RegEnumKeyEx( _
            hKey, key_num, subkey_name, subkey_length, _
            ByVal 0&, ByVal 0&, 0, file_time) _
                <> ERROR_SUCCESS Then Exit Do
        subkey_name = Left$(subkey_name, subkey_length)

        ' Display the information.
        If subkey_name <> "ODBC Data Sources" Then
            MSFlexGrid1.Rows = MSFlexGrid1.Rows + 1
            MSFlexGrid1.TextMatrix(MSFlexGrid1.Rows - 1, 0) = subkey_name
            MSFlexGrid1.TextMatrix(MSFlexGrid1.Rows - 1, 1) = _
                GetKeyValue(HKEY_LOCAL_MACHINE, _
                    "Software\ODBC\ODBC.INI\" & subkey_name, _
                    "Driver")
            MSFlexGrid1.TextMatrix(MSFlexGrid1.Rows - 1, 2) = _
                GetKeyValue(HKEY_LOCAL_MACHINE, _
                    "Software\ODBC\ODBC.INI\" & subkey_name, _
                    "Description")
        End If

        key_num = key_num + 1
    Loop

    ' Close the key.
    If RegCloseKey(hKey) <> ERROR_SUCCESS Then
        MsgBox "Error closing key."
    End If

    SizeColumns MSFlexGrid1
End Sub
Private Sub Form_Resize()
    MSFlexGrid1.Move 0, 0, ScaleWidth, ScaleHeight
End Sub
